// [=====================================================================]

//    Name:  KeyInjectModuleDlg.h     Last Modified:  
//    Author:							First Working:  
//  
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#if !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
#define AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_

#include <afxmt.h>
#include "idt_usb_hid.h"
#include "KeyDlg.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DES_MODE  = 0;
#define TDES_MODE = 1;


//#include "keyManager.h"
/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

class CKeyInjectModuleDlg : public CDialog
{
// Construction
public:
	CString m_Method;
	void InitDlg();
	BOOL m_isFrist;

	void Decryption();
	byte asctohex(byte m, byte n);	
	byte asctodec(byte m, byte n);
	CString	StrInput_Data;
	CString	StrInput;

	BYTE	m_Track1Buffer[1000];
	BYTE	m_Track2Buffer[1000];
	BYTE	m_Track3Buffer[1000];
	BYTE	m_SessionIDBuffer[16];
	
	DWORD	DataLen;
	DWORD	DataLen1;
	DWORD	DataLen2;
	DWORD	DataLen3;

	DWORD	m_CardType;
	BYTE	m_WholeCardDataBuf[400];
	UINT	WholeCardDataLen;
	CString	m_NotificationData;
	unsigned char m_cryptoKey[16];

	//DES type
	int m_des_index;
	CString	m_str_BDK;

	//array for KSN
	unsigned char m_cksn[20];  
    unsigned char m_nksn[10];     


	unsigned char m_nderivation_key[16];
	unsigned char m_ninitial_key[16];


	BOOL bTrk1;
	BOOL bTrk2;
	BOOL bTrk3;

	//Decryption Mode
	int bDecryptMode;
	int KBMode;
		
	KeyDlg   m_KeyDlg;

    CFont		m_font;
	CMenu		m_menu;
	UINT		m_Timer;

//	CKeyRetriver m_KetRtrvr;
	CKeyInjectModuleDlg(CWnd* pParent = NULL);	// standard constructor
	void Received_HID_Data(); 



// Dialog Data
	//{{AFX_DATA(CKeyInjectModuleDlg)
	enum { IDD = IDD_KEYINJECTMODULE_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeyInjectModuleDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CString		StrCommand;
	// Generated message map functions
	//{{AFX_MSG(CKeyInjectModuleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnEditchangeNoOfKeyParts();
	afx_msg void OnExit();
	afx_msg void OnSend();
	afx_msg void OnDecrypt();
	afx_msg void OnInputKey();
	afx_msg void OnMENUSetDefault();
	afx_msg void OnMENUReadConfiguration();
	afx_msg void OnMENUReadFirmware();
	afx_msg void OnMENUReadOnInsertionAndWithdrawal();
	afx_msg void OnMENUReadOnInsertion();
	afx_msg void OnMENUReportOnWithdrawal();
	afx_msg void OnMENUReadOnWithdrawal();
	afx_msg void OnMENUAbout();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMenuTdes();
	afx_msg void OnMenuAes();
	afx_msg void OnMENUSetPrePANClrData();
	afx_msg void OnMENUSetPostPANClrData();
	afx_msg void OnMENUSetMaskChar();
	afx_msg void OnMENUEnableLRC();
	afx_msg void OnMENUDisableLRC();
	afx_msg void OnMENURawData();
	afx_msg void OnMENUMSREnable();
	afx_msg void OnMENUMSRDisable();
	afx_msg void OnMENUSecurityLevel();
	afx_msg void OnMENUGetDeviceSN();
	afx_msg void OnMENUSetSessionID();
	afx_msg void OnActivateAuthentication();
	afx_msg void OnActivateChallengeReply();
	afx_msg void OnDeactivateChallengeReply();
	afx_msg void OnGetReaderStatus();
	afx_msg void OnDecodeAscii();
	afx_msg void OnDecodeHex();
	afx_msg void OnMenuGetksn();
	afx_msg void OnMenuUsbkbMode();
	afx_msg void OnMenuHidMode();
	afx_msg void OnMENUOriginalEncryptionFormat();
	afx_msg void OnMENUEnhancedEncryptionFormat();
	afx_msg void OnMENUForceEncryptAllTracks();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
	//int m_iEncrpt;
	CString m_strCOM;
	int m_iBrdRt;
	int m_iParity;
	int m_iDataBits;
	int m_iStopBits;
	int m_iInjectCount;
	CString		StrBuff;
	CString		StrScriptCommand;

	BOOL		MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd);
	BYTE		Char2Hex(char ch);	
	int  FileOpen();
	int  ExtractData();
	void ScriptData();

	bool		SendCommandRequest(byte* datapool, int outLength);
	CString		ReadString();
	int			ReadHex();
	void		DisplayHID_Data();
	void		SetDecodeMode(int decode);
	void		CheckReaderConnection(void);


	//unsigned char * GetXOR(const byte* key1,CString  key2,int  i);
	//unsigned char * GetXOR(const byte *key1, CString key2, int k,int iEncryptionMethod);
	
	//CString GetKeyCheckValue(CString key,int iEncrpt);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
